% Plot compliance ellipsoid at a foot
foot = 1;
Cjoint = diag([1/20 1/20]);
feet=[1 3 5];

figure(3)
clf;
Cfoot = diag([0.002 0.002 0.005 50*pi/180 50*pi/180 60*pi/180]);
options=1;
findComplianceOnly;
[VsOrig,DsOrig]=robotWithEllipsesComplianceOnly(robot,wgT,wTr,T_w1,T_w2,foot_pos,feet,gCeff);
title('Original Foot Compliance - Joint Compliance');
print -djpeg100 orig_joint_comp.jpg
figure(4)
options=2;
findComplianceOnly;
[VsOrig,DsOrig]=robotWithEllipsesComplianceOnly(robot,wgT,wTr,T_w1,T_w2,foot_pos,feet,gCeff);
title('Original Foot Compliance - Foot Structural Compliance');
print -djpeg100 orig_struct_comp.jpg
figure(5)
options=3;
findComplianceOnly;
[VsOrig,DsOrig]=robotWithEllipsesComplianceOnly(robot,wgT,wTr,T_w1,T_w2,foot_pos,feet,gCeff);
title('Original Foot Compliance - Total Compliance');
print -djpeg100 orig_total_comp.jpg
figure(6)
[VsKorig,DsKorig]=robotWithEllipses(robot,wgT,wTr,T_w1,T_w2,foot_pos,feet,bKeff,bKt,H);
title('Original Foot Stiffness - Total Stiffness');
print -djpeg100 orig_total_stiff.jpg

figure(7)
clf;
Cfoot = diag([0.0001 0.0001 0.0001 2*pi/180 2*pi/180 60*pi/180]);
options=1;
findComplianceOnly;
[VsZip,DsZip]=robotWithEllipsesComplianceOnly(robot,wgT,wTr,T_w1,T_w2,foot_pos,feet,gCeff);
title('Zip Tie Foot Compliance - Joint Compliance');
print -djpeg100 zip_joint_comp.jpg
figure(8)
options=2;
findComplianceOnly;
[VsZip,DsZip]=robotWithEllipsesComplianceOnly(robot,wgT,wTr,T_w1,T_w2,foot_pos,feet,gCeff);
title('Zip Tie Foot Compliance - Foot Structural Compliance');
print -djpeg100 zip_struct_comp.jpg
figure(9)
options=3;
findComplianceOnly;
[VsZip,DsZip]=robotWithEllipsesComplianceOnly(robot,wgT,wTr,T_w1,T_w2,foot_pos,feet,gCeff);
title('Zip Tie Foot Compliance - Total Compliance');
print -djpeg100 zip_total_comp.jpg
figure(10)
[VsKzip,DsKzip]=robotWithEllipses(robot,wgT,wTr,T_w1,T_w2,foot_pos,feet,bKeff,bKt,H);
title('Zip Tie Foot Stiffness - Total Stiffness');
print -djpeg100 zip_total_stiff.jpg


