function [g_foot_out,w_foot_out,gwT,foot_pos,T_g1_s,T_g2_s] = footWorkspace(robot,wgR,wgT,wTr,T_b0);
%draw ellipses showing permittable configuration of feet
%ie, solve zFoot in ground plane = 0 for phi and psi
%end of foot in lower_leg coordinates = [robot.lower_leg_length 0 0]

%debugging code
% clear all
% clc
% ground_plane=[0 0 1];
% robot=struct('cg',{[0,0,0]},...  %Center of the robot body in the world frame
%     'orient',{[0,0,0]},... %Pitch, roll, and yaw angles in degrees
%     'leg_posn',{[-0.75 1 0
%                  -0.75 0 0 
%                  -0.75 -1 0
%                  0.75 1 0
%                  0.75 0 0
%                  0.75 -1 0]},... %body coordinates to each hip
%     'leg_axes',{[0 1 0
%                  0 1 0
%                  0 1 0
%                  0 -1 0
%                  0 -1 0
%                  0 -1 0]},... %hip rotation axis
%     'leg_angles',{[30 -30
%                    30 -30
%                    30 -30
%                    30 30
%                    30 30
%                    30 30]},... %initial leg angles, phi and psi for each, in degrees
%     'width',{1.5},'length',{3},'height',{1},...  %size of the robot body
%     'upper_leg_length',{1},'lower_leg_length',{1},'leg_width',{0.2},... %sizes for the legs
%     'leg_depth',{0.2});
% [wgR,wgT] = getTransforms(ground_plane);
% figure(1);
% clf;
% drawGroundPlane(robot,wgT);
% [robot,wTr,T_b0,T_w1,T_w2]=robotVertices(robot);
% drawRobot(robot,wTr,T_w1,T_w2);
%end debugging code




%start main code
syms phi_s psi_s
for i=1:length(robot.leg_angles)
    T_12_s(:,:,i) = [cos(psi_s) -sin(psi_s)  0  robot.upper_leg_length
                     0        0             -1  0
                     sin(psi_s) cos(psi_s)   0  0
                     0        0              0  1];  %Lower leg coordinate system
    T_01_s(:,:,i) = [cos(phi_s) -sin(phi_s)   0     0
                     sin(phi_s)  cos(phi_s)   0     0
                     0           0            1     0
                     0           0            0     1];  %Upper leg coordinate system
    gwT=[wgR';[0 0 0]];
    gwT=[gwT [0;0;0;1]];
    T_g1_s(:,:,i) = gwT * wTr * T_b0(:,:,i) * T_01_s(:,:,i);
    T_g2_s(:,:,i) = T_g1_s(:,:,i) * T_12_s(:,:,i);
    foot_pos(:,i)=T_g2_s(:,:,i)*[robot.lower_leg_length; 0; 0; 1];
%    solve(foot_pos(3,i),'phi_s')
    eqn=solve(foot_pos(3,i),'psi_s');
    phi_t = 0:2*pi/100:2*pi;
    psi_t=subs(eqn,'phi_s',phi_t');
    k=1;
    clear phi_psi;
    for j=1:length(psi_t)
        if isreal(psi_t(j))
            phi_psi(:,k)=[phi_t(j); psi_t(j)];
            k=k+1;
        end
    end
    phi_psi=phi_psi';
    
    psi_t=subs(-eqn,'phi_s',phi_t');
    k=1;
    clear phi_psi_N;
    for j=1:length(psi_t)
        if isreal(psi_t(j))
            phi_psi_N(:,k)=[phi_t(j); psi_t(j)];
            k=k+1;
        end
    end
    phi_psi_N=phi_psi_N';
    
    eqn2=solve(foot_pos(3,i),'phi_s');
    psi2_t = 0:2*pi/100:2*pi;
    phi2_t=subs(eqn2,'psi_s',psi2_t');
    k=1;
    clear phi_psi2;
    for j=1:length(phi2_t)
        if isreal(phi2_t(j))
            phi_psi2(:,k)=[phi2_t(j); psi2_t(j)];
            k=k+1;
        end
    end
    phi_psi2=phi_psi2';
    
    phi2_t=subs(-eqn2,'psi_s',psi2_t');
    k=1;
    clear phi_psi2_N;
    for j=1:length(phi2_t)
        if isreal(phi2_t(j))
            phi_psi2_N(:,k)=[phi2_t(j); psi2_t(j)];
            k=k+1;
        end
    end
    phi_psi2_N=phi_psi2_N';

    
    clear foot_xyz;
    for j=1:size(phi_psi)*[1;0]
        foot_xyz(:,j)=subs(foot_pos(:,i),{phi_s,psi_s},{phi_psi(j,1),phi_psi(j,2)});
    end
    
    clear foot_xyz_N;
    for j=1:size(phi_psi_N)*[1;0]
        foot_xyz_N(:,j)=subs(foot_pos(:,i),{phi_s,psi_s},{phi_psi_N(j,1),phi_psi_N(j,2)});
    end

    clear foot_xyz2;
    for j=1:size(phi_psi2)*[1;0]
        foot_xyz2(:,j)=subs(foot_pos(:,i),{phi_s,psi_s},{phi_psi2(j,1),phi_psi2(j,2)});
    end
    
    clear foot_xyz2_N;
    for j=1:size(phi_psi2)*[1;0]
        foot_xyz2_N(:,j)=subs(foot_pos(:,i),{phi_s,psi_s},{phi_psi2_N(j,1),phi_psi2_N(j,2)});
    end

    w_foot_xyz = wgT*foot_xyz;
    w_foot_xyz_N = wgT*foot_xyz_N;
    w_foot_xyz2=wgT*foot_xyz2;
    w_foot_xyz2_N=wgT*foot_xyz2_N;
    
    g_foot_out(:,:,i) = [phi_psi'         phi_psi_N'         phi_psi2'         phi_psi2_N'
                         foot_xyz(1:3,:)  foot_xyz_N(1:3,:)  foot_xyz2(1:3,:)  foot_xyz2_N(1:3,:)];

    w_foot_out(:,:,i) = [phi_psi'           phi_psi_N'           phi_psi2'           phi_psi2_N'
                         w_foot_xyz(1:3,:)  w_foot_xyz_N(1:3,:)  w_foot_xyz2(1:3,:)  w_foot_xyz2_N(1:3,:)];
                     
end
