function varargout = foot_placement_gui(varargin)
% FOOT_PLACEMENT_GUI M-file for foot_placement_gui.fig
%      FOOT_PLACEMENT_GUI, by itself, creates a new FOOT_PLACEMENT_GUI or raises the existing
%      singleton*.
%
%      H = FOOT_PLACEMENT_GUI returns the handle to a new FOOT_PLACEMENT_GUI or the handle to
%      the existing singleton*.
%
%      FOOT_PLACEMENT_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FOOT_PLACEMENT_GUI.M with the given input arguments.
%
%      FOOT_PLACEMENT_GUI('Property','Value',...) creates a new FOOT_PLACEMENT_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before foot_placement_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to foot_placement_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help foot_placement_gui

% Last Modified by GUIDE v2.5 16-Jun-2004 13:16:48



% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @foot_placement_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @foot_placement_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before foot_placement_gui is made visible.
function foot_placement_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to foot_placement_gui (see VARARGIN)

% Choose default command line output for modaldlg
handles.output = [];

% Update handles structure
guidata(hObject, handles);

if nargin == 10
    for i=1:2:nargin
        switch varargin{i}
            case 'robot'
                handles.robot=varargin{i+1}
            case 'g_foot'
                handles.g_foot=varargin{i+1}
            case 'wTr'
                wTr=varargin{i+1}
            case 'T_b0'
                T_b0 = varargin{i+1}
            case 'gwT'
                gwT = varargin{i+1}
        end
    end
else
    handles.robot = evalin('base','robot');
    handles.g_foot = evalin('base','g_foot_out');
    wTr = evalin('base','wTr');
    T_b0 = evalin('base','T_b0');
    gwT = evalin('base','gwT');
end

for i=1:length(T_b0)
    handles.gTh(:,:,i) = gwT*wTr*T_b0(:,:,i);
    gRh = handles.gTh(1:3,1:3,i);
    handles.hTg(:,:,i) = [ [gRh';[0 0 0]] [-1*handles.gTh(1:3,4,i);1]];
end

% Create workspace plot
handles.leg_posns = [handles.robot.leg_posn, ones(length(handles.robot.leg_angles),1)]';
handles.leg_posns = [gwT*wTr*handles.leg_posns]';
handles.leg_posns = handles.leg_posns(:,1:3);
hold off
update_plot(handles);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes foot_placement_gui wait for user response (see UIRESUME)
uiwait(handles.figure1);



% --- Updates the plot in the gui
function update_plot(handles)
axes(handles.foot_plot)
hold off
for i=1:length(handles.leg_posns)
    plot(handles.g_foot(3,:,i),handles.g_foot(4,:,i),'r.');
    hold on
    text(handles.leg_posns(i,1),handles.leg_posns(i,2),num2str(i));
  
   %Plot selected x and y of foot.
    str=strcat('str2double(get(handles.Leg',num2str(i),'X,''String''))');
    x=eval(str);
    str=strcat('str2double(get(handles.Leg',num2str(i),'Y,''String''))');
    y=eval(str);
    if and(not(isempty(x)),not(isempty(y)))
        x=x+handles.leg_posns(i,1);
        y=y+handles.leg_posns(i,2);
        plot(x,y,'b>');
    end
end
axis equal
grid on


function [phi,psi,x_out,y_out] = find_closest(x_in,y_in,g_foot)
x=ones(1,size(g_foot)*[0;1])*x_in;
y=ones(1,size(g_foot)*[0;1])*y_in;
dist=(x-g_foot(3,:)).^2 + (y-g_foot(4,:)).^2;
[min_dist,ind_dist]=min(dist);
phi=g_foot(1,ind_dist);
psi=g_foot(2,ind_dist);
x_out=g_foot(3,ind_dist);
y_out=g_foot(4,ind_dist);


% --- Chooses closest x-y coord for a given leg
function choose_posn(leg,handles)
axes(handles.foot_plot)
instr_hold = get(handles.InstrText,'String');
set(handles.InstrText,'String',sprintf('Place Leg %d',leg));
[x_input,y_input]=ginput(1);
[phi,psi,x,y]=find_closest(x_input,y_input,handles.g_foot(:,:,leg));
%convert x-y to hip projection
x_hl=x-handles.leg_posns(leg,1);
y_hl=y-handles.leg_posns(leg,2);
str=strcat('set(handles.Leg',num2str(leg),'X,''String'',sprintf(''%3f'',x_hl));');
eval(str);
str=strcat('set(handles.Leg',num2str(leg),'Y,''String'',sprintf(''%3f'',y_hl));');
eval(str);
str=strcat('set(handles.Leg',num2str(leg),'Phi,''String'',sprintf(''Phi: %3f'',phi*180/pi));');
eval(str);
str=strcat('set(handles.Leg',num2str(leg),'Psi,''String'',sprintf(''Psi: %3f'',psi*180/pi));');
eval(str);
set(handles.InstrText,'String',instr_hold);

if get(handles.Symmetric,'Value') == get(handles.Symmetric,'Max')
    %do symmetric
    if leg <= 3
        clear handles.output;
        for i=1:3
            x_d=x_hl+handles.leg_posns(i,1);
            y_d=y_hl+handles.leg_posns(i,2);
            [phi_t,psi_t,x_t,y_t]=find_closest(x_d,y_d,handles.g_foot(:,:,i));
            x_h=x_t-handles.leg_posns(i,1);
            y_h=y_t-handles.leg_posns(i,2);
            str=strcat('set(handles.Leg',num2str(i),'X,''String'',sprintf(''%3f'',x_h));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Y,''String'',sprintf(''%3f'',y_h));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Phi,''String'',sprintf(''Phi: %3f'',phi_t*180/pi));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Psi,''String'',sprintf(''Psi: %3f'',psi_t*180/pi));');
            eval(str);
        end
        x_hl=-x_hl;
        for i=4:6
            x_d=x_hl+handles.leg_posns(i,1);
            y_d=y_hl+handles.leg_posns(i,2);
            [phi_t,psi_t,x_t,y_t]=find_closest(x_d,y_d,handles.g_foot(:,:,i));
            x_h=x_t-handles.leg_posns(i,1);
            y_h=y_t-handles.leg_posns(i,2);
            str=strcat('set(handles.Leg',num2str(i),'X,''String'',sprintf(''%3f'',x_h));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Y,''String'',sprintf(''%3f'',y_h));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Phi,''String'',sprintf(''Phi: %3f'',phi_t*180/pi));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Psi,''String'',sprintf(''Psi: %3f'',psi_t*180/pi));');
            eval(str);
        end
    else
        clear handles.output;
        for i=4:6
            x_d=x_hl+handles.leg_posns(i,1);
            y_d=y_hl+handles.leg_posns(i,2);
            [phi_t,psi_t,x_t,y_t]=find_closest(x_d,y_d,handles.g_foot(:,:,i));
            x_h=x_t-handles.leg_posns(i,1);
            y_h=y_t-handles.leg_posns(i,2);
            str=strcat('set(handles.Leg',num2str(i),'X,''String'',sprintf(''%3f'',x_h));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Y,''String'',sprintf(''%3f'',y_h));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Phi,''String'',sprintf(''Phi: %3f'',phi_t*180/pi));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Psi,''String'',sprintf(''Psi: %3f'',psi_t*180/pi));');
            eval(str);
        end
        x_hl=-x_hl;
        for i=1:3
            x_d=x_hl+handles.leg_posns(i,1);
            y_d=y_hl+handles.leg_posns(i,2);
            [phi_t,psi_t,x_t,y_t]=find_closest(x_d,y_d,handles.g_foot(:,:,i));
            x_h=x_t-handles.leg_posns(i,1);
            y_h=y_t-handles.leg_posns(i,2);
            str=strcat('set(handles.Leg',num2str(i),'X,''String'',sprintf(''%3f'',x_h));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Y,''String'',sprintf(''%3f'',y_h));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Phi,''String'',sprintf(''Phi: %3f'',phi_t*180/pi));');
            eval(str);
            str=strcat('set(handles.Leg',num2str(i),'Psi,''String'',sprintf(''Psi: %3f'',psi_t*180/pi));');
            eval(str);
        end
    end
end
update_plot(handles);
plot(x_input,y_input,'g<');

% --- Outputs from this function are returned to the command line.
function varargout = foot_placement_gui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% The figure can be deleted now
delete(handles.figure1);


% --- Executes on button press in Leg1Select.

function Leg1Select_Callback(hObject, eventdata, handles)

% hObject    handle to Leg1Select (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hint: get(hObject,'Value') returns toggle state of Leg1Select

choose_posn(1,handles);

% Update handles structure


guidata(hObject, handles);




% --- Executes on button press in Leg2Select.

function Leg2Select_Callback(hObject, eventdata, handles)

% hObject    handle to Leg2Select (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Leg2Select

choose_posn(2,handles);

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in Leg3Select.

function Leg3Select_Callback(hObject, eventdata, handles)

% hObject    handle to Leg3Select (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Leg3Select

choose_posn(3,handles);

% Update handles structure
guidata(hObject, handles);




% --- Executes during object creation, after setting all properties.

function Leg1X_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg1X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end





function Leg1X_Callback(hObject, eventdata, handles)

% hObject    handle to Leg1X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg1X as text

%        str2double(get(hObject,'String')) returns contents of Leg1X as a double





% --- Executes during object creation, after setting all properties.

function Leg1Y_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg1Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg1Y_Callback(hObject, eventdata, handles)

% hObject    handle to Leg1Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg1Y as text

%        str2double(get(hObject,'String')) returns contents of Leg1Y as a double





% --- Executes during object creation, after setting all properties.

function Leg2X_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg2X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg2X_Callback(hObject, eventdata, handles)

% hObject    handle to Leg2X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg2X as text

%        str2double(get(hObject,'String')) returns contents of Leg2X as a double





% --- Executes during object creation, after setting all properties.

function Leg2Y_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg2Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg2Y_Callback(hObject, eventdata, handles)

% hObject    handle to Leg2Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg2Y as text

%        str2double(get(hObject,'String')) returns contents of Leg2Y as a double





% --- Executes during object creation, after setting all properties.

function Leg3X_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg3X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg3X_Callback(hObject, eventdata, handles)

% hObject    handle to Leg3X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg3X as text

%        str2double(get(hObject,'String')) returns contents of Leg3X as a double





% --- Executes during object creation, after setting all properties.

function Leg3Y_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg3Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg3Y_Callback(hObject, eventdata, handles)

% hObject    handle to Leg3Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg3Y as text

%        str2double(get(hObject,'String')) returns contents of Leg3Y as a double





% --- Executes on button press in Symmetric.

function Symmetric_Callback(hObject, eventdata, handles)

% hObject    handle to Symmetric (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hint: get(hObject,'Value') returns toggle state of Symmetric





% --- Executes on button press in Leg4Select.

function Leg4Select_Callback(hObject, eventdata, handles)

% hObject    handle to Leg4Select (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hint: get(hObject,'Value') returns toggle state of Leg4Select

choose_posn(4,handles);

% Update handles structure
guidata(hObject, handles);







% --- Executes on button press in Leg5Select.

function Leg5Select_Callback(hObject, eventdata, handles)

% hObject    handle to Leg5Select (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hint: get(hObject,'Value') returns toggle state of Leg5Select

choose_posn(5,handles);

% Update handles structure
guidata(hObject, handles);







% --- Executes on button press in Leg6Select.

function Leg6Select_Callback(hObject, eventdata, handles)

% hObject    handle to Leg6Select (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hint: get(hObject,'Value') returns toggle state of Leg6Select

choose_posn(6,handles);

% Update handles structure
guidata(hObject, handles);





% --- Executes during object creation, after setting all properties.

function Leg4X_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg4X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg4X_Callback(hObject, eventdata, handles)

% hObject    handle to Leg4X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg4X as text

%        str2double(get(hObject,'String')) returns contents of Leg4X as a double





% --- Executes during object creation, after setting all properties.

function Leg4Y_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg4Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg4Y_Callback(hObject, eventdata, handles)

% hObject    handle to Leg4Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg4Y as text

%        str2double(get(hObject,'String')) returns contents of Leg4Y as a double





% --- Executes during object creation, after setting all properties.

function Leg5X_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg5X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg5X_Callback(hObject, eventdata, handles)

% hObject    handle to Leg5X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg5X as text

%        str2double(get(hObject,'String')) returns contents of Leg5X as a double





% --- Executes during object creation, after setting all properties.

function Leg5Y_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg5Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg5Y_Callback(hObject, eventdata, handles)

% hObject    handle to Leg5Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg5Y as text

%        str2double(get(hObject,'String')) returns contents of Leg5Y as a double





% --- Executes during object creation, after setting all properties.

function Leg6X_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg6X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg6X_Callback(hObject, eventdata, handles)

% hObject    handle to Leg6X (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg6X as text

%        str2double(get(hObject,'String')) returns contents of Leg6X as a double





% --- Executes during object creation, after setting all properties.

function Leg6Y_CreateFcn(hObject, eventdata, handles)

% hObject    handle to Leg6Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    empty - handles not created until after all CreateFcns called



% Hint: edit controls usually have a white background on Windows.

%       See ISPC and COMPUTER.

if ispc

    set(hObject,'BackgroundColor','white');

else

    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

end







function Leg6Y_Callback(hObject, eventdata, handles)

% hObject    handle to Leg6Y (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)



% Hints: get(hObject,'String') returns contents of Leg6Y as text

%        str2double(get(hObject,'String')) returns contents of Leg6Y as a double





% --- Executes on button press in OK.

function OK_Callback(hObject, eventdata, handles)

% hObject    handle to OK (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)
for i=1:length(handles.robot.leg_posn)
    str=strcat('get(handles.Leg',num2str(i),'Phi,''String'')');
    phi=eval(str);
    [token,rem] = strtok(phi);
    phi=str2double(rem);
    str=strcat('get(handles.Leg',num2str(i),'Psi,''String'')');
    psi=eval(str);
    [token,rem] = strtok(psi);
    psi=str2double(rem);
    output(i,:)=[phi psi];
end    

handles.output=output;
guidata(hObject, handles);
uiresume;


% --- Executes on button press in CANCEL.

function CANCEL_Callback(hObject, eventdata, handles)

% hObject    handle to CANCEL (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB

% handles    structure with handles and user data (see GUIDATA)
handles.output=[];
guidata(hObject, handles);
%foot_placement_gui_OutputFcn(hObject, eventdata, handles)

uiresume;

