function [wgR,wgT] = getTransforms(ground_plane)
%Form transform from world to ground frame (pure rotation - z-axis of
%ground coordinates is the normal to the plane.  Other axes determined by
%cross product with world Y axis (unless normal is Y, then it's X...)
n=ground_plane'/norm(ground_plane);
v=[0;1;0];
if (dot(cross(n,v),cross(n,v)))==0
    u=cross([0;0;1],n);
else
    u=cross(v,n);
end
v=cross(n,u);
wgR=[u v n];
wgT=[wgR;[0 0 0]];
wgT=[wgT [0;0;0;1]];

