function [Vs,Ds]=robotWithEllipses(robot,wgT,wTr,T_w1,T_w2,foot_pos,feet,bKeff,bKt,H)
% PLOTS SCALED STIFFNESS
syms phi_s psi_s;

scale=1e5;

drawGroundPlane(robot,wgT);
drawRobot(robot,wTr,T_w1,T_w2,0.5);

for i=1:size(robot.leg_posn)*[1;0]
    g_foot_pos(:,i)=subs(foot_pos(:,i),{phi_s psi_s},{robot.leg_angles(i,1)*pi/180,robot.leg_angles(i,2)*pi/180});
end

Vs=zeros(size(H*H',1),size(H*H',2),size(robot.leg_posn,1));
Ds=Vs;

for i=1:length(feet)
    bKsm=H*bKeff(:,:,feet(i))*H';
    [Vs(:,:,feet(i)),Ds(:,:,feet(i))]=eig(bKsm);
    eigers=diag(Ds(:,:,feet(i)))/scale;
    [X,Y,Z]=ellipsoid(0,0,0,eigers(1),eigers(2),eigers(3));
    [X2,Y2,Z2]=surfrotate(X,Y,Z,Vs(:,:,feet(i)),g_foot_pos(1:3,feet(i)));
    plotSurf(X2,Y2,Z2,[0 0 1],0.5);
end

%Body Stiffness (is this accurate? Is knocking it down to 3D allowable??)
bKsm=H*bKt*H';
[VsBody,DsBody]=eig(bKsm);
eigers=diag(DsBody)/scale;
[X,Y,Z]=ellipsoid(0,0,0,eigers(1),eigers(2),eigers(3));
[X2,Y2,Z2]=surfrotate(X,Y,Z,VsBody,robot.cg);
plotSurf(X2,Y2,Z2,[0 1 0],0.5);
